<template>
    <div class="container mt-4">
      <div class="row">
        <!-- Left Column (3/12) -->
        <div class="col-md-3">
          <!-- Add tabs, e.g., My Profile -->
          <ul class="nav flex-column">
            <li class="nav-item">
              <router-link to="/profile" class="nav-link">My Profile</router-link>
            </li>
            <!-- Add other tabs here -->
          </ul>
        </div>
  
        <!-- Middle Column (6/12) -->
        <div class="col-md-6">
          <h2 class="text-center mb-4">Recent posts</h2>
          <div class="post-list">
            <!-- Use the PostList component to display posts as 3D cards -->
            <div class="post-card" v-for="post in allPosts" :key="post.slug">
              <div class="post-content">
                <h3 class="post-title">{{ post.title }}: {{ post.subtitle }}</h3>
                <div class="post-info">
                    <div class="post-author">
                        By <router-link :to="'/author/' + post.author.user.username">{{ post.author.user.username }}</router-link>
                    </div>
                    <div class="post-date">{{ formatDate(post.publishDate) }}</div>
                    </div>
                <p class="post-description">{{ post.metaDescription }}</p>
                <div class="post-tags">
                    <router-link
                        v-for="tag in tags"
                        :key="tag.name"
                        :to="'/tag/' + tag.name"
                        >
                        #{{ tag.name }}
                        </router-link>
                </div>
                <div class="post-stats">
                  <div class="post-likes">Likes: {{ post.likedByUsersCount.length }}</div>
                  <div class="post-comments">Comments: {{ post.commentsCount.length }}</div>
                  <div class="post-hashtags">
                    Hashtags: {{ post.tags.map(tag => `#${tag.name}`).join(', ') }}
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
  
        <!-- Right Column (3/12) -->
        <div class="col-md-3">
          <!-- Add additional content in the right column if needed -->
        </div>
      </div>
    </div>
  </template>
  
  <script>
  export default {
    name: "ThreeColumnLayout",
    props: {
      allPosts: {
        type: Array,
        required: true,
      },
    },
    methods: {
      formatDate(date) {
        return new Date(date).toLocaleDateString("en-US", {
          year: "numeric",
          month: "long",
          day: "numeric",
        });
      },
    },
  };
  </script>
  
  <style scoped>
  .post-card {
    background-color: #fff;
    box-shadow: 0 2px 4px rgba(0, 0, 0, 0.1);
    border: 1px solid #e0e0e0;
    border-radius: 5px;
    padding: 1rem;
    margin-bottom: 1rem;
    transition: transform 0.2s ease-in-out;
  }
  
  .post-card:hover {
    transform: scale(1.03);
  }
  
  .post-title {
    font-size: 1.25rem;
    font-weight: bold;
    margin: 0.5rem 0;
  }
  
  .post-info {
    display: flex;
    align-items: center;
    margin-bottom: 0.5rem;
  }
  
  .post-author {
    font-weight: bold;
  }
  
  .post-date {
    margin-left: 1rem;
    color: #888;
  }
  
  .post-description {
    color: #555;
    margin-bottom: 1rem;
  }
  
  .post-tags {
    margin-bottom: 1rem;
  }
  
  .post-tags a {
    margin-right: 0.5rem;
    text-decoration: none;
    color: #007bff;
  }
  
  .post-stats {
    display: flex;
    justify-content: space-between;
    color: #888;
  }
  
  .post-likes,
  .post-comments,
  .post-hashtags {
    flex: 1;
    text-align: center;
  }
  
  /* Responsive styling */
  @media (max-width: 768px) {
    .col-md-3 {
      display: none;
    }
    .col-md-6 {
      width: 100%;
    }
  }
  </style>
  